/***************************************************
* By CCSC compiler
*  File Name: MK327_K444_1829.c
*  Description: check compus module and turn on relay / LEDs
*  COPYRIGHT 2016 MYCOMKITS.COM, owned by CNET LIMITED
*  $BEv%W%m%0%i%`$NCx:n8"$O!"@=:n<T!V%^%$%3%s%-%C%H%I%C%H%3%`1?1D!!M-8B2q<R%/%M%C%H!W$K5"B0$7$^$9!#(B
*  $BCx:n8"$rJ|4~$7$F$$$^$;$s$,!"Ev%W%m%0%i%`$r;H$C$?3X=,$NCf$G%W%m%0%i%`$r<+M3$KJQ99$7$F$*;H$$$/$@$5$$!#(B
***************************************************/
//#define RAND_MAX 80
#include <16f1829.h>
#DEVICE ADC=10
#fuses	INTRC_IO, NOWDT, NOMCLR, NOBROWNOUT, PUT, NOLVP, NOPROTECT, NODEBUG
#fuses	NOCPD, NOWRT, NOIESO, NOFCMEN, NOSTVREN
#use	delay(CLOCK = 4000000)
#use I2C(MASTER, SDA = pin_A4, SCL = pin_A5)
#use rs232(BAUD = 9600, XMIT = PIN_C4)
#include <math.h>
//#include <stdlib.h>
//
#use	fast_io(a)
#use	fast_io(b)
#use	fast_io(c)
//
#ROM getenv("EEPROM_ADDRESS") = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}// get 15 bytes
//#ROM 0x00
#byte OSCCON = 0x099
#byte WPUA = 0x20C
#byte WPUB = 0x20D
#byte WPUC = 0x20E
#byte OPTION_REG = 0x095
#byte PCON = 0x096
//
#define Amode 0xF8			//port A all out, except A3,4,5,5,7
#define	Bmode 0x00			//port B all OUT
#define Cmode 0x20			//port C all out, except C5
#define LED0 PIN_A0
#define LED30 PIN_C0
#define LED60 PIN_C1
#define LED90 PIN_C2
#define LED120 PIN_B4
#define LED150 PIN_B5
#define LED180 PIN_B6
#define LED210 PIN_B7
#define LED240 PIN_C7
#define LED270 PIN_C6
#define LED300 PIN_A2
#define LED330 PIN_A1
#define calsw PIN_A3
#define setsw PIN_C5
#define relay PIN_C3
//
#define HMC5883L_READ_ADDR       0x3D
#define HMC5883L_WRITE_ADDR      0x3C
#define Config_Reg_A             0x00
#define Config_Reg_B             0x01
#define Mode_Reg                 0x02
#define X_MSB_Reg                0x03
#define X_LSB_Reg                0x04
#define Z_MSB_Reg                0x05
#define Z_LSB_Reg                0x06
#define Y_MSB_Reg                0x07
#define Y_LSB_Reg                0x08
#define Status_Reg               0x09
#define ID_Reg_A                 0x0A
#define ID_Reg_B                 0x0B
#define ID_Reg_C                 0x0C
#define declination_angle     -0.5167   // For Uttara, Dhaka, Bangladesh
// variables
register signed long X_axis = 0;
register signed long Y_axis = 0;
register signed long Z_axis = 0;
signed long Xadj = -126;
signed long Yadj = -384;
signed long X_axis_min=0;
signed long X_axis_max=0;
signed long Y_axis_min=0;
signed long Y_axis_max=0;
//
float dir = 0.0;    // direction
float adj_value = -44.67;
//
int1 LED0flag=0;
int1 LED30flag=0;
int1 LED60flag=0;
int1 LED90flag=0;
int1 LED120flag=0;
int1 LED150flag=0;
int1 LED180flag=0;
int1 LED210flag=0;
int1 LED240flag=0;
int1 LED270flag=0;
int1 LED300flag=0;
int1 LED330flag=0;
long cal_time=0;
signed long Xvalue[4];
signed long Yvalue[4];
int gain_value = 0x20;  //0, 0x20, 40, 60, 80, A0, C0, E0
int out_count = 0;
int1 target_flag = 0;
float target_adj = 0;
int target_count=0;
int relay_mode=0;
// prototyping
#separate
void HMC5883L_init();
#separate
unsigned char HMC5883L_read(unsigned char reg);
#separate
void HMC5883L_write(unsigned char reg_address, unsigned char value);
#separate
void HMC5883L_read_data();
#separate
float HMC5883L_angle();
#separate
void initializing();
#separate
void clear_all_LED();
#separate
void clear_all_flag();
#separate
void LED_ON();
#separate
void HMC5883L_cal();
#separate
void HMC5883L_cal2();
#separate
void HMC5883L_mov_average();
#separate
void HMC5883L_set_gain(float max_gauss);
#separate
void HMC5883L_target();
#separate
void LED_ON2();
#separate
void roulet();
#separate
void WRITE_FLOAT_EEPROM(int addr, float data);
#separate
float READ_FLOAT_EEPROM(int addr);
#separate
void WRITE_LONG_EEPROM(int addr, signed long data);
#separate
signed long READ_LONG_EEPROM(int addr);
// main function
void main()
{
	initializing();
        HMC5883L_init();
	// main loop
	while(1)
	{
            HMC5883L_cal();
            dir = HMC5883L_angle();
            //
            if(out_count == 0) 
            {
                printf("\n\rX=%ld Y=%ld Z=%ld Xadj=%ld Yadj=%ld dir=%f",X_axis, Y_axis, Z_axis, Xadj, Yadj, dir);
                out_count = 30;
            }
            else out_count -= 1;
            //
            LED_ON();
            HMC5883L_target();
            //
	}
}
//
#separate
void initializing()
{
    set_tris_a(Amode);	//
    set_tris_b(Bmode);	//
    set_tris_c(Cmode);	//
    //
    setup_comparator(NC_NC_NC_NC);
    SETUP_DAC(DAC_OFF);
    setup_oscillator(OSC_4MHZ | OSC_PLL_OFF);
    // A/D converter initialize
    setup_adc_ports(NO_ANALOGS);	// gnd to fixed voltage reference
    //
    OPTION_REG = 0x7F & OPTION_REG;	// pull up enable
    //
    WPUA = 0x08;	// pull up A3
    WPUC = 0x20;	// pull up C5
    //
    clear_all_LED();
    if(input(setsw) == 0)
    {
        if(read_eeprom(0x0E) == 0x01)   // turn relay on at target
        {
            relay_mode = 0x02;    //
            write_eeprom(0x0E, 2);  // set 2, turn relay off at target
            // blinking 2 times
            output_low(LED180);
            delay_ms(300);
            output_high(LED180);
            delay_ms(300);
            output_low(LED180);
            delay_ms(300);
            output_high(LED180);
        }
        else
        {
            relay_mode = 0x01;    //
            write_eeprom(0x0E, 1);  // set 1, turn relay on at target
            // blinking 1 times
            output_low(LED180);
            delay_ms(300);
            output_high(LED180);
            //
        }
    }
    while(input(setsw) == 0) {}
    if(read_eeprom(0x0E) == 0x02)
    {
        relay_mode = 0x02;    //
    }
    else if(read_eeprom(0x0E) == 0x01)
    {
        relay_mode = 0x01;    //
    }
    else
    {
        relay_mode = 0x01;    //
        write_eeprom(0x0E, 1);  // set 1, turn relay on at target
    }
    //eeprom adrs 0 = 1st run flag
    if(read_eeprom(0) == 0x01)
    {
        Xadj = READ_LONG_EEPROM(0x01);
        Yadj = READ_LONG_EEPROM(0x03);
        target_flag = read_eeprom(0x05);
        dir = READ_FLOAT_EEPROM(0x06);
        target_adj = READ_FLOAT_EEPROM(0x0A);
    }
    else
    {
        Xadj = -48; // factory default value
        Yadj = -220; // factory default value
        write_eeprom(0, 0x01);
        WRITE_LONG_EEPROM(0x01, Xadj);
        WRITE_LONG_EEPROM(0x03, Yadj);
    }
    //
    if(relay_mode == 0x01) output_high(relay); // relay off
    else output_low(relay); // relay on
}
//
#separate
void HMC5883L_init()
{
   int i;
    HMC5883L_write(Config_Reg_A, 0x70);  // default
   //
   HMC5883L_write(Mode_Reg, 0x00);  // continuous mode
   HMC5883L_set_gain(1.3);  // max gauss is -/+1.3
   //
   signed long Xtempo = 0;
   signed long Ytempo = 0;
   for(i=0; i<4; i++)
   {
        HMC5883L_read_data();
        delay_ms(100);
        Xtempo += X_axis;
        Ytempo += Y_axis;
   }
   X_axis = Xtempo/4;
   Y_axis = Ytempo/4;
   for(i=0; i<4; i++)
   {
       Xvalue[i] = X_axis;
       Yvalue[i] = Y_axis;
   }
   X_axis_min = X_axis;
   X_axis_max = X_axis;
   Y_axis_min = Y_axis;
   Y_axis_max = Y_axis;
}
//
#separate
unsigned char HMC5883L_read(unsigned char reg)
{
   unsigned char val = 0;

   I2C_Start();
   I2C_Write(HMC5883L_WRITE_ADDR);
   I2C_Write(reg);
   I2C_Start();
   I2C_Write(HMC5883L_READ_ADDR);
   val = I2C_Read(0);
   I2C_Stop();
   return(val);
}
//
#separate
void HMC5883L_write(unsigned char reg_address, unsigned char value)
{
   I2C_Start();
   I2C_Write(HMC5883L_WRITE_ADDR);
   I2C_Write(reg_address);
   I2C_Write(value);
   I2C_Stop();
}
//
#separate
void HMC5883L_read_data()
{
   unsigned char lsb = 0;
   unsigned char msb = 0;
    //
   I2C_Start();
   I2C_Write(HMC5883L_WRITE_ADDR);
   I2C_Write(X_MSB_Reg);
   I2C_Start();
   I2C_Write(HMC5883L_READ_ADDR);
    //
   msb = I2C_Read();
   lsb = I2C_Read();
   X_axis = make16(msb, lsb);
   //
   msb = I2C_Read();
   lsb = I2C_Read();
   Z_axis = make16(msb, lsb);
   //
   msb = I2C_Read();
   lsb = I2C_Read(0);
   Y_axis = make16(msb, lsb);
   //
   I2C_Stop();
}
//
#separate
float HMC5883L_angle()
{
   register float angle = 0.0;
   //
   HMC5883L_read_data();
   HMC5883L_mov_average();
   angle = atan2(Y_axis-Yadj, X_axis-Xadj);
   angle *= (180.0 / PI);
   //a
   angle = angle - 130-adj_value;
   if(angle > 360) angle = angle - 360;
   if(angle < 0) angle = angle + 360;
   return angle;
}
//
#separate
void clear_all_LED()
{
    output_high(LED0);
    output_high(LED30);
    output_high(LED60);
    output_high(LED90);
    output_high(LED120);
    output_high(LED150);
    output_high(LED180);
    output_high(LED210);
    output_high(LED240);
    output_high(LED270);
    output_high(LED300);
    output_high(LED330);
}
//
#separate
void clear_all_flag()
{
    LED0flag=0;
    LED30flag=0;
    LED60flag=0;
    LED90flag=0;
    LED120flag=0;
    LED150flag=0;
    LED180flag=0;
    LED210flag=0;
    LED240flag=0;
    LED270flag=0;
    LED300flag=0;
    LED330flag=0;
}
//
#separate
void LED_ON()
{
    clear_all_flag();
    LED_ON2();
}
//
#separate
void HMC5883L_cal()
{
    //
    if(input(calsw) == 0)
    {
        delay_ms(50);
        if(input(calsw) == 0)
        {
            HMC5883L_cal2();
        }
    }
    //
}
//
#separate
void HMC5883L_cal2()
{
    //
    int led_no = 0;
    long cal_time2;
    // blinking 2 times
    output_low(LED0);
    delay_ms(300);
    output_high(LED0);
    delay_ms(300);
    output_low(LED0);
    delay_ms(300);
    output_high(LED0);
    //
    cal_time2 = 20000;    // almost 10 sec
    while(cal_time2 > 0)
    {
        cal_time2 = cal_time2 - 1;
        if(cal_time2%500 == 0)    // every 100msec
        {
            HMC5883L_read_data();
            HMC5883L_mov_average();
            if(X_axis < X_axis_min) X_axis_min = X_axis;
            if(X_axis > X_axis_max) X_axis_max = X_axis;
            if(Y_axis < Y_axis_min) Y_axis_min = Y_axis;
            if(Y_axis > Y_axis_max) Y_axis_max = Y_axis;
            //
            printf("\n\rX=%ld Y=%ld Xmin=%ld Xmax=%ld Ymin=%ld Ymax=%ld",X_axis, Y_axis, X_axis_min, X_axis_max, Y_axis_min, Y_axis_max);
            //
            clear_all_LED();
            led_no = led_no + 1;
            if(led_no > 11) led_no = 0;
            if(led_no == 0)  output_low(LED0);
            else if(led_no == 1)  output_low(LED30);
            else if(led_no == 2)  output_low(LED60);
            else if(led_no == 3)  output_low(LED90);
            else if(led_no == 4)  output_low(LED120);
            else if(led_no == 5)  output_low(LED150);
            else if(led_no == 6)  output_low(LED180);
            else if(led_no == 7)  output_low(LED210);
            else if(led_no == 8)  output_low(LED240);
            else if(led_no == 9)  output_low(LED270);
            else if(led_no == 10)  output_low(LED300);
            else if(led_no == 11)  output_low(LED330);
            //
        }
    }
    Xadj = (X_axis_min + X_axis_max)/2;
    Yadj = (Y_axis_min + Y_axis_max)/2;
    WRITE_LONG_EEPROM(0x01, Xadj);
    WRITE_LONG_EEPROM(0x03, Yadj);
    // blinking 3 times
    output_low(LED0);
    delay_ms(300);
    output_high(LED0);
    delay_ms(300);
    output_low(LED0);
    delay_ms(300);
    output_high(LED0);
    output_low(LED0);
    delay_ms(300);
    output_high(LED0);
    printf("\n\rX=%ld Y=%ld Z=%ld Xadj=%ld Yadj=%ld dir=%f",X_axis, Y_axis, Z_axis, Xadj, Yadj, dir);
    delay_ms(100);
    //
}
// moving average
#separate
void HMC5883L_mov_average()
{
    int i;
    signed long Xsum = 0;
    signed long Ysum = 0;
    for(i=3; i>0; i--)
    {
        Xvalue[i] = Xvalue[i-1];
        Yvalue[i] = Yvalue[i-1];
    }
    Xvalue[0] = X_axis;
    Yvalue[0] = Y_axis;
    for(i=0; i<4; i++)
    {
        Xsum = Xsum + Xvalue[i];
        Ysum = Ysum + Yvalue[i];
    }
    X_axis = Xsum / 4;
    Y_axis = Ysum / 4;
}
//
#separate
void HMC5883L_set_gain(float max_gauss)
{
    if(max_gauss == 0.88) gain_value = 0x00;
    else if(max_gauss == 1.3) gain_value = 0x20;
    else if(max_gauss == 1.9) gain_value = 0x40;
    else if(max_gauss == 2.5) gain_value = 0x60;
    else if(max_gauss == 4.0) gain_value = 0x80;
    else if(max_gauss == 4.7) gain_value = 0xA0;
    else if(max_gauss == 5.6) gain_value = 0xC0;
    else if(max_gauss == 8.1) gain_value = 0xE0;
    HMC5883L_write(Config_Reg_B, gain_value);
}
//
#separate
void HMC5883L_target()
{
    if(input(setsw) == 0)
    {
        delay_ms(50);
        if(input(setsw) == 0)
        {
            if(target_flag == 0)
            {
                target_flag = 1;
                
                dir = HMC5883L_angle();
                target_adj = dir - 360; // 0 to -360
                write_eeprom(5, 0x01);
                WRITE_FLOAT_EEPROM(6, dir);
                WRITE_FLOAT_EEPROM(10, target_adj);
                // blinking 2 times
                output_low(LED0);
                delay_ms(300);
                output_high(LED0);
                delay_ms(300);
                output_low(LED0);
                delay_ms(300);
                output_high(LED0);
            }
            else
            {
                target_flag = 0;
                write_eeprom(5, 0);
                output_low(LED0);
                delay_ms(300);
                output_high(LED0);
                delay_ms(300);
                output_low(LED0);
                delay_ms(300);
                output_high(LED0);
                delay_ms(300);
                output_low(LED0);
                delay_ms(300);
                output_high(LED0);
            }
        }
        while(input(setsw) == 0) {}
    }
    if(target_flag == 1)
    {
        dir = dir -  target_adj;
        if(dir < 0) dir += 360;
        if(dir > 360) dir -= 360;
        if(dir>350 || dir<=0)
        {
            if(relay_mode == 0x01) output_low(relay);    // center 0, cover 10degree
            else output_high(relay);
        }
        else 
        {
            if(relay_mode == 0x01) output_high(relay);    // center 0, cover 10degree
            else output_low(relay);
        }
        if(target_count == 0)
        {
            LED_ON2();
            target_count = 30;
        }
        else target_count -=1;
    }
    else 
    {
        if(relay_mode == 0x01) output_high(relay);    // center 0, cover 10degree
        else output_low(relay);
    }
}
//
#separate
void LED_ON2()
{
    //
    if(dir>337.5 || dir<=22.5) LED0flag=1;    // center 0, cover 45degree
    if(dir>307.5 && dir<=352.5) LED30flag=1;    // center 330
    if(dir>277.5 && dir<=322.5) LED60flag=1;    // center 300
    if(dir>248.5 && dir<=292.5) LED90flag=1;    // center 270
    if(dir>217.5 && dir<=262.5) LED120flag=1;    // center 240
    if(dir>187.5 && dir<=232.5) LED150flag=1;    // center 210
    if(dir>157.5 && dir<=202.5) LED180flag=1;    // center 180
    if(dir>127.5 && dir<=172.5) LED210flag=1;    // center 150
    if(dir>97.5 && dir<=142.5) LED240flag=1;    // center 120
    if(dir>67.5 && dir<=112.5) LED270flag=1;    // center 90
    if(dir>37.5 && dir<=82.5) LED300flag=1;    // center 60
    if(dir>7.5 && dir<=52.5) LED330flag=1;    // center 30
    //
    if(LED0flag == 1) output_low(LED0);
    else output_high(LED0);
    if(LED30flag == 1) output_low(LED30);
    else output_high(LED30);
    if(LED60flag == 1) output_low(LED60);
    else output_high(LED60);
    if(LED90flag == 1) output_low(LED90);
    else output_high(LED90);
    if(LED120flag == 1) output_low(LED120);
    else output_high(LED120);
    if(LED150flag == 1) output_low(LED150);
    else output_high(LED150);
    if(LED180flag == 1) output_low(LED180);
    else output_high(LED180);
    if(LED210flag == 1) output_low(LED210);
    else output_high(LED210);
    if(LED240flag == 1) output_low(LED240);
    else output_high(LED240);
    if(LED270flag == 1) output_low(LED270);
    else output_high(LED270);
    if(LED300flag == 1) output_low(LED300);
    else output_high(LED300);
    if(LED330flag == 1) output_low(LED330);
    else output_high(LED330);
}
//write_float_to_eeprom;
#separate
void WRITE_FLOAT_EEPROM(int addr, float data)
{
   int8 i;
   for (i = 0; i < 4; i++)
   {
      write_eeprom(addr + i, *((int8*)&data + i));
      delay_ms(20);
   }
}
//read_float_from_eeprom;
#separate
float READ_FLOAT_EEPROM(int addr)
{
   int8 i;
   float data=0;
   for (i = 0; i < 4; i++)
   {
      *((int8*)&data + i) = read_eeprom(addr + i);
      delay_ms(20);
   }
   return(data);
}
//write_long_to_eeprom;
#separate
void WRITE_LONG_EEPROM(int addr, signed long data)
{
   int8 i;
   for (i = 0; i < 2; i++)
    {
        write_eeprom(addr + i, *((int8*)&data + i));
        delay_ms(20);
    }
}
//read_long_from_eeprom;
#separate
signed long READ_LONG_EEPROM(int addr)
{
    int8 i;
    signed long data=0;
    for (i = 0; i < 2; i++)
    {
        *((int8*)&data + i) = read_eeprom(addr + i);
        delay_ms(20); 
    }
    return(data);
}
//